unit frmKvalifikace_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmKvalifikace = class(TForm)
    btnKonec: TButton;
    lblNadpis: TLabel;
    pnlPodklad: TPanel;
    rdgPracovnici: TRadioGroup;
    grbStroje: TGroupBox;
    chbSoustruh: TCheckBox;
    chbHorizontka: TCheckBox;
    chbVrtacka: TCheckBox;
    chbHoblovka: TCheckBox;
    chbBruska: TCheckBox;
    chbLaser1: TCheckBox;
    chbLaser2: TCheckBox;
    chbTrumatic: TCheckBox;
    chbV_nuzky: TCheckBox;
    chbN_nuzky: TCheckBox;
    btnPotvrdit: TButton;
    btnVratit: TButton;
    btnUlozit: TButton;
    btnPrehled: TButton;
    svdUlozSoubor: TSaveDialog;
    procedure btnKonecClick(Sender: TObject);
    procedure rdgPracovniciClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnVratitClick(Sender: TObject);
    procedure btnPotvrditClick(Sender: TObject);
    procedure btnUlozitClick(Sender: TObject);
    procedure btnPrehledClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmKvalifikace: TfrmKvalifikace;

implementation

{$R *.dfm}
type
  kompetence = ARRAY[0..20,0..20] of tcheckBoxState;
var
  CanWork : kompetence;
  f       : file of kompetence;

procedure TfrmKvalifikace.btnKonecClick(Sender: TObject);
begin
  close;
end;



procedure TfrmKvalifikace.btnPotvrditClick(Sender: TObject);
var
  i,j, MaxStroj : smallint;
begin
  i := frmKvalifikace.rdgPracovnici.ItemIndex;//index pracovnika
  MaxStroj := frmKvalifikace.grbStroje.ControlCount;
  for j := 0 to MaxStroj - 1 do
    CanWork[i,j] := (frmKvalifikace.grbStroje.Controls[j] as tCheckBox).State;

  frmKvalifikace.grbStroje.Enabled    := false;
  frmKvalifikace.btnPotvrdit.Enabled  := false;
  frmKvalifikace.btnVratit.Enabled    := false;
  frmKvalifikace.btnUlozit.Enabled    := true;

end;

procedure TfrmKvalifikace.btnPrehledClick(Sender: TObject);
var
  MaxPrac, MaxStroj,i: smallInt;
  appPath : string;
  VystSoubor : string;
  t : textfile;
  Jmeno:string;
begin
    MaxPrac := frmKvalifikace.rdgPracovnici.ControlCount;
    MaxStroj := frmKvalifikace.grbStroje.ControlCount;

    getDir(0, appPath);
    frmKvalifikace.svdUlozSoubor.InitialDir := appPath;

    if frmKvalifikace.svdUlozSoubor.Execute then
      VystSoubor := frmKvalifikace.svdUlozSoubor.FileName //ziskane jmeno souboru
    else
      exit;

    assignFile(t,VystSoubor);
    rewrite(t);

    write(t,'':20);
    for I := 0 to MaxStroj - 1 do
      write(t,copy((frmKvalifikace.grbStroje.Controls[i] as tCheckBox).Name,4,6),' ');
    writeln(t);
    for I := 1 to 20 + MaxStroj*(6+1) do write(t,'=');

    writeln(t);
    for I := 0 to MaxPrac - 1 do
    begin
      jmeno :=  frmKvalifikace.rdgPracovnici.Items[i];  //jmeno pracovnika
      while length(jmeno)<20 do jmeno := jmeno + ' ';
      write(t,jmeno);

      writeln(t);
    end;

   closefile(t);
end;

procedure TfrmKvalifikace.btnUlozitClick(Sender: TObject);
begin
  rewrite(f);
  write(f,CanWork);
  closefile(f);
  frmKvalifikace.btnUlozit.Enabled    := false;
end;

procedure TfrmKvalifikace.btnVratitClick(Sender: TObject);
var
  i,j, MaxStroj : smallint;
begin
  i := frmKvalifikace.rdgPracovnici.ItemIndex;//index pracovnika
  MaxStroj := frmKvalifikace.grbStroje.ControlCount;
  for j := 0 to MaxStroj - 1 do
    (frmKvalifikace.grbStroje.Controls[j] as tCheckBox).State := CanWork[i,j];
end;

procedure TfrmKvalifikace.FormCreate(Sender: TObject);
var
  I: Integer;
  J: Integer;
  MaxPrac, MaxStroj:integer;
begin
  assignfile(f, 'Kvalifikace.hid');
  {$i-}
  reset(f);
  {$i+}
  if IOResult <> 0  then begin
    //soubor neexistuje
    showMessage('Soubor s kompetencemi neexistuje');
    MaxPrac := frmKvalifikace.rdgPracovnici.ControlCount;
    MaxStroj := frmKvalifikace.grbStroje.ControlCount;
    //nastaveni pocatecnich hodnot
    for I := 0 to MaxPrac - 1 do
      for J := 0 to MaxStroj - 1 do
        CanWork[i,j] := cbUnchecked;
  end
  else begin
    //soubor existuje
    read(f,CanWork);
    closefile(f);
  end;


end;

procedure TfrmKvalifikace.rdgPracovniciClick(Sender: TObject);
var
  i,j, MaxStroj : smallint;
begin
  i := frmKvalifikace.rdgPracovnici.ItemIndex;//index pracovnika
  MaxStroj := frmKvalifikace.grbStroje.ControlCount;
  for j := 0 to MaxStroj - 1 do
    (frmKvalifikace.grbStroje.Controls[j] as tCheckBox).State := CanWork[i,j];

  frmKvalifikace.grbStroje.Enabled    := true;
  frmKvalifikace.btnPotvrdit.Enabled  := true;
  frmKvalifikace.btnVratit.Enabled    := true;
  //frmKvalifikace.btnUlozit.Enabled    := false;
end;

end.
